#!/bin/sh
PATH=/bin:/usr/bin:/sbin:/usr/sbin:/usr/local/bin
DJBMODE=${1:-tinydns}

rm -f /service/* 2>/dev/null
if [ "$DJBMODE" = tinydns ] ; then
    if ! [ -f /usr/local/etc/tinydns/root/data ] ; then
        tinydns-conf tinydns dnslog /usr/local/etc/tinydns 0.0.0.0
    fi
    if ! [ -f /usr/local/etc/axfrdns/tcp ] ; then
        axfrdns-conf axfrdns dnslog /usr/local/etc/axfrdns /usr/local/etc/tinydns 0.0.0.0
    fi
    ln -s /usr/local/etc/tinydns /service/tinydns
    ln -s /usr/local/etc/axfrdns /service/axfrdns
elif [ "$DJBMODE" = dnscache ] ; then
    if ! [ -f /usr/local/etc/dnscache/env/IP ] ; then
        dnscache-conf dnscache dnslog /usr/local/etc/dnscache 0.0.0.0
        echo 1 > /usr/local/etc/dnscache/env/FORWARDONLY
    fi
    ln -s /usr/local/etc/dnscache /service/dnscache
elif [ "$DJBMODE" = walldns ] ; then
    if ! [ -f /usr/local/etc/walldns/env/IP ] ; then
        walldns-conf walldns dnslog /usr/local/etc/walldns 0.0.0.0
    fi
    ln -s /usr/local/etc/walldns /service/walldns
elif [ "$DJBMODE" = rbldns ] ; then
    if ! [ -f /usr/local/etc/rbldns/env/IP ] ; then
        rbldns-conf rbldns dnslog /usr/local/etc/rbldns 0.0.0.0 mydomain.local
    fi
    ln -s /usr/local/etc/rbldns /service/rbldns
else
    echo "Unknown mode" 1>&2
    exit 1
fi

svscan /service
